<template>
  <div>
    <Spin fix v-show="priceloading">
      <Icon type="ios-loading" size="18" class="demo-spin-icon-load"></Icon>
      <div>{{ $t('loading') }}</div>
    </Spin>
    <Card class="gray" dis-hover>
      <h2 class="tc">{{ $t('components.ticketgroup.title') }}</h2>
      <h4 class="tc">{{ $t('components.ticketgroup.title2') }}</h4>
      <Form label-position="top" class="mt-20" inline>
        <FormItem :label="$t('personticket.idnum')">
          <i-Input v-model="idnum" type="text"></i-Input>
        </FormItem>
        <FormItem :label="$t('personticket.mail')">
          <i-Input v-model="mail" type="email"></i-Input>
        </FormItem>
        <FormItem :label="$t('personticket.Seatpreference')">
          <RadioGroup type="button" v-model="seattype">
            <Radio label="0">{{ $t('personticket.nospecify') }}</Radio>
            <Radio label="1">{{ $t('personticket.Tableseatpriority') }}</Radio>
            <Radio label="2">{{ $t('personticket.Parent-childcarpriority') }}</Radio>
          </RadioGroup>
        </FormItem>
        <FormItem :label="$t('personticket.ticketcount_normal')">
          <InputNumber :max="6" :min="0" v-model="normalseat"></InputNumber>
        </FormItem>
        <FormItem :label="$t('personticket.chgseat')">
          <i-switch size="large" class="ml-10" v-model="chgseat">
            <span slot="close">{{ $t('personticket.no') }}</span>
            <span slot="open">{{ $t('personticket.yes') }}</span>
          </i-switch>
        </FormItem>
        <FormItem :label="$t('personticket.needwheelseat')">
          <CheckboxGroup>
            <InputNumber :max="6" :min="0" v-show="showseat" v-model="helpseat"></InputNumber>
            <i-switch size="large" v-model="showseat" class="ml-10">
              <span slot="close">{{ $t('personticket.no') }}</span>
              <span slot="open">{{ $t('personticket.yes') }}</span>
            </i-switch>
          </CheckboxGroup>
        </FormItem>
      </Form>
    </Card>
    <Card class="mt-10 bg goborderl" dis-hover>
      <h1 class="fr">
        <Icon type="md-train" />
        |{{ $t('personticket.Onewayticket') }}
      </h1>
      <Form label-position="top" class="mt-5" inline>
        <h2 class="mb-15" v-if="ticketmsg !=''">
          {{ticketmsg.TrainDate}}|
          {{ticketmsg.OriginStopTime.StationName.Zh_tw}}
          {{ticketmsg.OriginStopTime.DepartureTime}}{{ $t('personticket.go') }} {{ $t('personticket.to') }}
          {{ticketmsg.DestinationStopTime.StationName.Zh_tw}}
          {{ticketmsg.DestinationStopTime.ArrivalTime}} {{ $t('personticket.arrive') }}
        </h2>
        <FormItem :label="$t('personticket.Trips')" v-if="ticketmsg !=''">
          <h3>
            <font
              v-if="ticketmsg.DailyTrainInfo.TrainTypeCode === '7' "
            >{{ $t('components.trainborard.Shuttlebusfast') }}</font>
            <font
              v-if="ticketmsg.DailyTrainInfo.TrainTypeCode === '6' "
            >{{ $t('components.trainborard.Shuttlebusfast') }}</font>
            <font
              v-if="ticketmsg.DailyTrainInfo.TrainTypeCode === '10'"
            >{{ $t('components.trainborard.normalfast') }}</font>
            <font
              v-if="ticketmsg.DailyTrainInfo.TrainTypeCode === '5' "
            >{{ $t('components.trainborard.Shuttlebus') }}</font>
            <font
              v-if="ticketmsg.DailyTrainInfo.TrainTypeCode === '4' "
            >{{ $t('components.trainborard.ChuKuang') }}</font>
            <font
              v-if="ticketmsg.DailyTrainInfo.TrainTypeCode === '3' "
            >{{ $t('components.trainborard.TzeChiang') }}</font>
            <font
              v-if="ticketmsg.DailyTrainInfo.TrainTypeCode === '2' "
            >{{ $t('components.trainborard.Puoma') }}</font>
            <font
              v-if="ticketmsg.DailyTrainInfo.TrainTypeCode === '1' "
            >{{ $t('components.trainborard.TarokoExpress') }}</font>
            - ({{ticketmsg.DailyTrainInfo.TrainNo}})
          </h3>
        </FormItem>
        <FormItem :label="$t('personticket.Seatpreference')">
          <h3 v-if="seattype == '0'">{{$t('personticket.nospecify')}}</h3>
          <h3 v-if="seattype == '1'">{{$t('personticket.Tableseatpriority')}}</h3>
          <h3 v-if="seattype == '2'">{{$t('personticket.Parent-childcarpriority')}}</h3>
        </FormItem>
        <FormItem :label="$t('personticket.chgseat')">
          <h3 v-if="chgseat">{{$t('personticket.yes')}}</h3>
          <h3 v-if="!chgseat">{{$t('personticket.no')}}</h3>
        </FormItem>
        <FormItem :label="$t('personticket.Generalseat')">
          <h3>{{normalseat}} {{$t('personticket.Bit')}}</h3>
        </FormItem>
        <FormItem :label="$t('personticket.Wheelchairseat')" v-show="showseat">
          <h3 v-show="showseat">{{helpseat}} {{$t('personticket.Bit')}}</h3>
        </FormItem>
        <FormItem :label="$t('personticket.ticketprice')" v-if="price!=''">
          <h1
            v-if="ticketmsg.DailyTrainInfo.TrainTypeCode === '1'"
          >${{(normalseat+helpseat)*(price[0].Fares[0].Price+13)}} {{$t('personticket.money')}}</h1>
          <h1
            v-if="ticketmsg.DailyTrainInfo.TrainTypeCode === '2'"
          >${{(normalseat+helpseat)*(price[0].Fares[0].Price+31)}} {{$t('personticket.money')}}</h1>
          <h1
            v-if="ticketmsg.DailyTrainInfo.TrainTypeCode === '3'"
          >${{(normalseat+helpseat)*(price[0].Fares[0].Price)}} {{$t('personticket.money')}}</h1>
          <h1
            v-if="ticketmsg.DailyTrainInfo.TrainTypeCode === '4'"
          >${{(normalseat+helpseat)*(price[0].Fares[5].Price)}} {{$t('personticket.money')}}</h1>
          <h1
            v-if="ticketmsg.DailyTrainInfo.TrainTypeCode === '5'"
          >${{(normalseat+helpseat)*(price[0].Fares[10].Price)}} {{$t('personticket.money')}}</h1>
          <h1
            v-if="ticketmsg.DailyTrainInfo.TrainTypeCode === '6'"
          >${{(normalseat+helpseat)*(price[0].Fares[15].Price+33)}} {{$t('personticket.money')}}</h1>
          <h1
            v-if="ticketmsg.DailyTrainInfo.TrainTypeCode === '7'"
          >${{(normalseat+helpseat)*(price[0].Fares[15].Price)}} {{$t('personticket.money')}}</h1>
          <h1
            v-if="ticketmsg.DailyTrainInfo.TrainTypeCode === '10'"
          >${{(normalseat+helpseat)*(price[0].Fares[15].Price+23)}} {{$t('personticket.money')}}</h1>
        </FormItem>
      </Form>
    </Card>
    <Modal
      v-model="talkmodal"
      class-name="vertical-center-modal"
      width="600"
      :styles="{top: '-5rem'}"
    >
      <h2 slot="header" style="color:#f60;line-height: 1rem;" class="tc">
        <Icon type="md-bicycle" />
        <span>{{$t('components.ticketgroup.modtitle')}}</span>
      </h2>
      <div style="text-align:center;">
        <p>{{$t('components.ticketgroup.moddata1')}}</p>
        <br />
        <p>{{$t('components.ticketgroup.moddata2')}}</p>
      </div>
      <div slot="footer">
        <Button type="primary" size="large" @click="talkmodal=false">{{$t('index.close')}}</Button>
      </div>
    </Modal>
  </div>
</template>

<script>
import firebase from "firebase/app";
import moment from "moment";
import selectdate from "~/components/tools/selectdate.vue";
export default {
  components: {
    selectdate
  },
  
  data() {
    return {
      ticketmsg: [],
      showseat: false,
      talkmodal: false,
      selectgoback: false,
      chgseat: false,
      seattype: "0",
      helpseat: 0,
      normalseat: 1,
      price: "",
      priceloading: false,
      acount: [],
      idnum: "",
      mail: ""
    };
  },
  mounted() {
    this.acount = JSON.parse(localStorage.getItem("logindata"));
  },
  watch: {
    showseat(bool) {
      if (bool) {
        return (this.talkmodal = !this.talkmodal), (this.helpseat = 1);
      }
      if (!bool) {
        return (this.helpseat = 0);
      }
    },
    "$store.getters.ticketitmodaldata"() {
      this.ticketmsg = this.$store.getters.ticketitmodaldata;
      this.ticketprice(
        this.ticketmsg.OriginStopTime.StationID,
        this.ticketmsg.DestinationStopTime.StationID
      );
    }
  },
  methods: {
    cancel() {
      (this.ticketmsg = []),
      (this.showseat = false),
      (this.selectgoback = false),
      (this.chgseat = false),
      (this.seattype = "0"),
      (this.helpseat = 0),
      (this.normalseat = 1),
      (this.price = ""),
      (this.idnum = ""),
      (this.mail = "");
      this.showseat = !this.showseat;
    },
    async ticketprice(start, end) {
      this.priceloading = !this.priceloading;
      const price = await this.$axios.$get(
        `ODFare/${start}/to/${end}?$top=30&$format=JSON`
      );
      this.price = price;
      this.priceloading = !this.priceloading;
    },
    async sendticket() {
      this.priceloading = !this.priceloading;
      const countticket = this.helpseat + this.normalseat;
      const setdata = {
        /*票卷狀態*/ backtcket: "0",
        /*會員ID*/ uid: this.acount.user.uid,
        /*身分證字號*/ idnum: this.idnum,
        /*mail*/ mail: this.mail,

        /*座位喜好*/ seatlike: this.seattype,
        /*車次*/ trainno: this.ticketmsg.DailyTrainInfo.TrainNo,
        /*車種*/ traintype: this.ticketmsg.DailyTrainInfo.TrainTypeCode,

        /*票種*/ tickettype: 0,
        /*票價*/ ticketprice: this.price,
        /*總票數*/ ticketnum: countticket,
        /*可否換位*/ chgseat: this.chgseat,
        /*需要輪椅位*/ whweelseat: this.showseat,
        /*輪椅座位*/ whweelseatnum: this.helpseat,
        /*一般座位*/ seatnum: this.normalseat,

        /*日期*/ date: this.ticketmsg.TrainDate,
        /*開始時間*/ starttime: this.ticketmsg.OriginStopTime.DepartureTime,
        /*結束時間*/ endtime: this.ticketmsg.DestinationStopTime.ArrivalTime,
        /*起站*/ startarea: this.ticketmsg.OriginStopTime.StationName.Zh_tw,
        /*抵站*/ endarea: this.ticketmsg.DestinationStopTime.StationName.Zh_tw,
        /*購票時間*/ buydate: moment(Date.now()).format("LLLL")
      };
      if (this.idnum == "" || this.mail == "") {
        this.$Message.error(this.$t("personticket.plscheckform"));
      } else {
        await firebase;
        const db = firebase.firestore();
        const ref = db.collection("ticket");
        await ref
          .add(setdata)
          .then(data => {
            this.$emit("outticketbridge");
            this.$Message.success(this.$t("personticket.yesticket"));
          })
          .catch(error => {
            this.$Message.error(this.$t("personticket.happenerror"));
          });
      }
      this.priceloading = !this.priceloading;
    }
  }
};
</script>
